/*************************************************
Projet TDC_JS

Auteur : Jean Marc Wehrlen, 2011

Version 20120228

INDICATION DE LICENCE :
Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier au titre des clauses de la Licence Publique Gnrale Affero GNU, telle que publie par la Free Software Foundation, version 3 ou une version ultrieure de la Licence,  votre choix. 
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. Voir la Licence Publique Gnrale Affero GNU pour plus de dtails : <http://www.gnu.org/licenses/agpl.html>.

LICENSE INDICATION IN ENGLISH :
This program is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details: <http://www.gnu.org/licenses/agpl.html>.

*****************************************************/
var q1, q2, answer, remainder, question, answerSize, exoSize, counter, numberRight, currentMistakeCount,eta;//integers
var elQuestion, elAnswer, elRWord, elRemainder, elRemainderDisplay, elNumberDone, elNumberRight, elDivDone, elDivRight, elCheckButton, elStopwatchDisplay, elStopwatchDisplayPrompt, elStopwatchConfigPrompt;//elements
var interval;//stopwatch handle
var ignoreTimer, timerDelay, fixedOrder, numbersInFixedPlace, timerHidden, respectSpaces,strictDecimalComa;//config variables


function initialize(){
	timerDelay=timerDelay?timerDelay:0;
	fixedOrder=fixedOrder?fixedOrder:0;
	timerHidden=timerHidden?timerHidden:0;
	strictDecimalComa=strictDecimalComa?strictDecimalComa:0;//0 on accepte le point dcimal  la place de la virugle, 1 on prvient qu'il faut mettre une virgule  la place d'un point, 2 idem, mais on compte comme une erreur, 3 on compte un point dcimal pour une erreur standard sans commentaire particulier
	eta=timerDelay;
	ignoreTimer=ignoreTimer?ignoreTimer:0;
	exoSize=table.length;
	q1=new Array(exoSize);
	q2=new Array(exoSize);
	question=new Array(exoSize);
	answer=new Array(exoSize);
	remainder=new Array(exoSize);
	answerSize=new Array(exoSize);
	for(var i=0;i<exoSize;i++)answerSize[i]=2;
	var shuffleBase=getShuffleBase(exoSize);
	table=shuffleArray(table,shuffleBase);
	for(var i = 0;i<exoSize;i++) loadArrays(i);
	elQuestion=document.getElementById("question");
	elAnswer=document.getElementById("answerInput");
	elRWord=document.getElementById("rWord");
	elRemainder=document.getElementById("remainderInput");
	elNumberDone=document.getElementById("numberDone");
	elNumberRight=document.getElementById("numberRight");
	elDivDone=document.getElementById("divDone");
	elDivRight=document.getElementById("divSucceeded");
	elCheckButton=document.getElementById("checkButton");
	elStopwatchDisplay=document.getElementById("stopwatchDisplay");
	elStopwatchDisplayPrompt=document.getElementById("stopwatchDisplayPrompt");
	elStopwatchConfigPrompt=document.getElementById("stopwatchConfigPrompt");
	counter=0;
	numberRight=0;
	currentMistakeCount=0;
	var str= ".......";
	elQuestion.innerHTML=str;
	if(timerHidden) hideTimer();
	if(timerDelay) elStopwatchDisplay.innerHTML=formatTimerDisplay(eta);
	else elStopwatchDisplay.style.visibility="hidden";
	updateScorepanel();
	elAnswer.value="";
	elRemainder.value="";
	elAnswer.focus();
	}


function hideTimer(){
	elStopwatchDisplay.style.visibility="hidden";
	elStopwatchDisplayPrompt.style.visibility="visible";
	elStopwatchConfigPrompt.style.visibility="visible";
	if(interval) clearInterval(interval);
	ignoreTimer=1;
	elAnswer.focus();
	}

function showTimer(){
	elStopwatchDisplay.style.visibility="visible";
	elStopwatchDisplayPrompt.style.visibility="hidden";
	elStopwatchConfigPrompt.style.visibility="hidden";
	ignoreTimer=0;
eta=timerDelay;
elStopwatchDisplay.innerHTML=formatTimerDisplay(eta);
	if(elCheckButton.value=="Vrifier" && (elQuestion.value.indexOf("=")>-1 || elQuestion.value.indexOf("->")>-1) ) interval=setInterval("decreaseStopwatch()",1000);
	elAnswer.focus();
	}

function formatTimerDisplay(i){
//return ""+i+"&nbsp;sec";
	if(i<10) return "&nbsp;"+i+"&nbsp;sec&nbsp;";
	else return ""+i+"&nbsp;sec";
}

function setTimerDelay(){
var userChoice=prompt("Indiquer le dlai du minuteur en secondes");
//alert(userChoice);
timerDelay=userChoice?parseInt(userChoice):timerDelay;
eta=timerDelay;
}

function updateScorepanel(){
if(counter>1) elNumberDone.innerHTML="Faits : "+counter+"/"+exoSize;
else elNumberDone.innerHTML="Fait : "+counter+"/"+exoSize;
elDivDone.style.width=300*counter/exoSize+"px";
if(numberRight>1) elNumberRight.innerHTML="Russis : "+numberRight+"/"+exoSize;
else elNumberRight.innerHTML="Russi : "+numberRight+"/"+exoSize;
elDivRight.style.width=300*numberRight/exoSize+"px";
	}

function accessk(ev){
	var e=ev?ev:window.event;
	var t=e.target ? e.target:e.srcElement;
	if (e.keyCode==13) {//when in text input, press enter to check answer
		var i = t.id.substring(1, t.id.length);
		checkIt();
		}
	}


function makeupQuestion(i,sign){
	if(sign==":") return q1[i]+" : "+q2[i]+" ->";
	if(numbersInFixedPlace) return q1[i]+" "+sign+" "+q2[i]+" = ";
	var str=q1[i]+" "+sign+" "+q2[i]+" = ";
	if(parseInt((Math.random()*10))%2) str=q2[i]+" "+sign+" "+q1[i]+" = ";
	return str;
	}

function displayQuestion(i){
if(/:/.test(question[i])) {elRWord.style.visibility="visible";elRemainder.style.visibility="visible";}
else {elRWord.style.visibility="hidden";elRemainder.style.visibility="hidden";}
elQuestion.innerHTML=question[i];
elAnswer.value="";
elAnswer.style.width=answerSize[i]+"em";
elRemainder.value="";
elAnswer.focus();
	}

function loadArrays(i){
	var tempArray, sSign;
	if(table[i].indexOf("=") > -1) {loadStrArrays(i,"=");return;}//if sign "=" then arrays should be considered as strings with answers included in data table
	if(table[i].indexOf("->") > -1) {loadStrArrays(i,"->");return;}//if sign "->" then arrays should be considered as strings with answers included in data table
	else if(table[i].indexOf("x") > -1) sSign="x";//else no answers included in data table and table will be split into integers
	else if(table[i].indexOf("+") > -1) sSign="+";
	else if(table[i].indexOf("-") > -1) sSign="-";
	else if(table[i].indexOf("/") > -1) sSign="/";
	else if(table[i].indexOf(":") > -1) sSign=":";
	tempArray=table[i].split(sSign);
	q1[i]=parseInt(tempArray[0],10);
	q2[i]=parseInt(tempArray[1],10);
	remainder[i]=null;
	switch(sSign){
	case "x":answer[i]=q1[i]*q2[i];break;
	case "+":answer[i]=q1[i]+q2[i];break;
	case "-":answer[i]=q1[i]-q2[i];numbersInFixedPlace=1;break;
	case "/": answer[i]=q1[i]/q2[i];numbersInFixedPlace=1;break;
	case ":": answer[i]=parseInt(q1[i]/q2[i]);remainder[i]=q1[i]%q2[i]; numbersInFixedPlace=1;break;
	}
	question[i]=makeupQuestion(i, sSign);
	}

function loadStrArrays(i,sSign){//if arrays are strings and answers are included in table
	var tempArray;
	tempArray=table[i].split(sSign);
	question[i]=tempArray[0]+" "+sSign+" ";
	answer[i]=formatAnswer(tempArray[1]);
	answerSize[i]=5;
	}

function decreaseStopwatch(){
if(!timerDelay) return;
		if(eta>1) {
			eta--;
			elStopwatchDisplay.innerHTML=formatTimerDisplay(eta);
			}
		else {
			eta=0;
			elStopwatchDisplay.innerHTML=formatTimerDisplay(eta);
			elAnswer.style.background="yellow";
			currentMistakeCount++;
			clearInterval(interval);
			}
			
	}

function startStopwatch(){
	interval=setInterval("decreaseStopwatch()",1000);
	}

function formatAnswer(s){
var sResult=s;
if(!respectSpaces) sResult=sResult.replace(/\s/g,"");
if(!strictDecimalComa) sResult=sResult.replace(/\./g,",");
sResult=sResult.replace(/^0+/,"");//enlever les zros si devant le nombre
sResult=sResult.replace(/^,/,"0,");//rajouter un zros si le nombre commence par une virgule
if(/,/.test(sResult)) sResult=sResult.replace(/0+$/,"");
sResult=sResult.replace(/,$/,"");//enlever la virgule s'il n'y a plus rien derrire (par exemple "3,0" qui est devenu "3," suite  prcdente ligne)
return sResult;
}

function checkIt(){
	if(elCheckButton.value=="Commencer"){
		elCheckButton.value="Vrifier";
		displayQuestion(counter);
		if(elStopwatchDisplay.style.visibility=="visible") startStopwatch();
		return;
	}
	if(counter==exoSize) {
		clearInterval(interval);
		elAnswer.value="";
		elRemainder.value="";

		elRWord.style.visibility="hidden";elRemainder.style.visibility="hidden";
		return;
		}
	if(formatAnswer(elAnswer.value)==answer[counter] && (remainder[counter]==null || elRemainder.value==remainder[counter])) {
		elAnswer.style.background="white";
		elRemainder.style.background="white";
		if(!currentMistakeCount) numberRight++;
		if(counter<exoSize-1) {
			counter++;
			updateScorepanel();
			currentMistakeCount=0;
			displayQuestion(counter);
			clearInterval(interval);
			eta=timerDelay;
			elStopwatchDisplay.innerHTML=formatTimerDisplay(eta);
			if(!ignoreTimer) interval=setInterval("decreaseStopwatch()",1000);
			}
		else {
			counter=exoSize;
			updateScorepanel();
if(counter==numberRight) elQuestion.innerHTML="Bravo !";
else			elQuestion.innerHTML="Fin&nbsp;de&nbsp;l'exercice";
			elAnswer.value="";
			elRemainder.value="";
elRWord.style.visibility="hidden";elRemainder.style.visibility="hidden";
			clearInterval(interval);
			eta=timerDelay;
			elStopwatchDisplay.innerHTML=formatTimerDisplay(eta);
			}
		}
	else if(strictDecimalComa<3 && elAnswer.value.indexOf(".")>-1 && answer[counter].indexOf(",")>-1){
		alert("Peut-tre faut-il remplacer le point par une virugle ?");
		if(strictDecimalComa==2)currentMistakeCount++;
		}
	else {
		currentMistakeCount++;
		if(elRemainder.style.visibility=="visible" && elRemainder.value!=remainder[counter]) {
			elRemainder.style.background="red";
			elRemainder.focus();
			}
		if(elAnswer.value!=answer[counter]) {
			elAnswer.style.background="red";
			elAnswer.focus();
			}
		
		}
	}

function getShuffleBase(size){
	var shuffleArray=new Array(size);
	for(var i=0;i<size;i++)shuffleArray[i]=Math.random()+"a"+i;
	shuffleArray.sort();
	for(var i = 0;i<size;i++)shuffleArray[i]=shuffleArray[i].substring(shuffleArray[i].indexOf("a")+1,shuffleArray[i].length);
	return shuffleArray;
	}


function shuffleArray(ar, shuffleBase){
	var size=ar.length;
	var result=new Array(size);
	if(!fixedOrder) for(var i = 0;i<size;i++) result[i]=ar[shuffleBase[i]];
	else for(var i = 0;i<size;i++) result[i]=ar[i];
	return result;
	}




